//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "lib_crc.h"
#include "FTD2XX.h"
#include "ScenerEMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormS *FormS;
//---------------------------------------------------------------------------
__fastcall TFormS::TFormS(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormS::FormCreate(TObject *Sender)
{
        if(CreateUSBPort()) {
                ComboBoxInChange(ComboBoxIn);
                BufComand[0] = 0;
                BufComand[1] = 1;
                TransimittData((BYTE)0x03,(WORD)2,BufComand); //Laser On
        }
}
//---------------------------------------------------------------------------
bool __fastcall TFormS::CreateUSBPort()
{
        bool result = true;
        if ((USB_Device_HANDLE != NULL)&&(USB_Device_HANDLE != INVALID_HANDLE_VALUE)) {
                FT_W32_EscapeCommFunction(USB_Device_HANDLE, SETBREAK);
                FT_W32_CloseHandle(USB_Device_HANDLE);
        }
        USB_Device_HANDLE =FT_W32_CreateFile("D2XX Recovery PID for XP",GENERIC_READ|GENERIC_WRITE,0,0,
                              OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL |FT_OPEN_BY_DESCRIPTION,0);
        if (USB_Device_HANDLE != INVALID_HANDLE_VALUE) {
                FT_W32_SetupComm(USB_Device_HANDLE, 32, 32);
                FT_W32_PurgeComm(USB_Device_HANDLE, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
                FT_W32_SetCommMask(USB_Device_HANDLE, EV_RXCHAR | EV_TXEMPTY);
                USB_Device_cto.ReadIntervalTimeout =         50;
                USB_Device_cto.ReadTotalTimeoutMultiplier =  50;
                USB_Device_cto.ReadTotalTimeoutConstant =    1000;
                USB_Device_cto.WriteTotalTimeoutMultiplier = 50;
                USB_Device_cto.WriteTotalTimeoutConstant = 1;
                FT_W32_SetCommTimeouts(USB_Device_HANDLE, &USB_Device_cto);
                FT_W32_GetCommState(USB_Device_HANDLE, &USB_Device_dcb);
                USB_Device_dcb.DCBlength = sizeof(USB_Device_dcb);

                USB_Device_dcb.BaudRate = (DWORD)921600;

                USB_Device_dcb.ByteSize = 8;
                USB_Device_dcb.Parity = NOPARITY;
                USB_Device_dcb.StopBits = ONESTOPBIT;
                USB_Device_dcb.fBinary = 1;
                USB_Device_dcb.fParity = 0;
                USB_Device_dcb.fOutxCtsFlow = 0;
                USB_Device_dcb.fOutxDsrFlow = 0;
                USB_Device_dcb.fDtrControl = DTR_CONTROL_DISABLE;
                USB_Device_dcb.fDsrSensitivity = 0;
                USB_Device_dcb.fTXContinueOnXoff = 0;
                USB_Device_dcb.fOutX = 0;
                USB_Device_dcb.fInX = 0;
                USB_Device_dcb.fErrorChar = 0;
                USB_Device_dcb.fNull = 0;
                USB_Device_dcb.fRtsControl = RTS_CONTROL_DISABLE;
                USB_Device_dcb.fAbortOnError = 0;
                FT_W32_SetCommState(USB_Device_HANDLE, &USB_Device_dcb);
        } else {
                Application->MessageBox("Error.","",MB_ICONWARNING);
                USB_Device_HANDLE = NULL;
                result = false;
        }
        return(result);
}
//---------------------------------------------------------------------------
void __fastcall TFormS::CloseUSBPort()
{
        if ((USB_Device_HANDLE != NULL)&&(USB_Device_HANDLE != INVALID_HANDLE_VALUE)) {
                FT_W32_EscapeCommFunction(USB_Device_HANDLE, SETBREAK);
                FT_W32_CloseHandle(USB_Device_HANDLE);
        }
        USB_Device_HANDLE = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TFormS::FormClose(TObject *Sender, TCloseAction &Action)
{
        if ((USB_Device_HANDLE != NULL)&&(USB_Device_HANDLE != INVALID_HANDLE_VALUE))
                CloseUSBPort();
}
//---------------------------------------------------------------------------
void __fastcall TFormS::TransimittData(BYTE Cm, WORD Len, BYTE* Buff)
{
        BYTE Tr_Byte, NetAddrDev = 0x20;
        WORD crc_16 = 0x0000;
        DWORD NWrite;

        FT_W32_PurgeComm(USB_Device_HANDLE, FT_PURGE_RX | FT_PURGE_TX);
        //-- Transmitt Marker--
        Tr_Byte = NetAddrDev & mask_UA_DATA;;
        FT_W32_WriteFile(USB_Device_HANDLE, &Tr_Byte, 1, &NWrite, NULL);
        //-- Transmitt Length--
        for (WORD ind = 0; ind < con_UA_LEN_Length; ind++) {
                Tr_Byte =  Len >> (7*ind);
                Tr_Byte |= mask_UA_MARKER;
                FT_W32_WriteFile(USB_Device_HANDLE, &Tr_Byte, 1, &NWrite, NULL);
        }
        //-- Transmitt Command--
        crc_16 = update_crc_16(crc_16, Cm);
        Cm |= mask_UA_MARKER;
        FT_W32_WriteFile(USB_Device_HANDLE, &Cm,1,&NWrite,NULL);
        //-- Transmitt Data--
        for (WORD ind = 0; ind < Len; ind++) {
                Tr_Byte = *(Buff+ind);
                crc_16 = update_crc_16(crc_16, Tr_Byte);                
                Tr_Byte |= mask_UA_MARKER;
                FT_W32_WriteFile(USB_Device_HANDLE, &Tr_Byte, 1, &NWrite, NULL);
        }
        //-- Transmitt CRC--
        for (WORD ind = 0; ind < con_UA_CRC_Length; ind++) {
                Tr_Byte =  crc_16 >> (7*ind);
                Tr_Byte |= mask_UA_MARKER;
                FT_W32_WriteFile(USB_Device_HANDLE, &Tr_Byte, 1, &NWrite, NULL);
        }
}
//---------------------------------------------------------------------------
bool __fastcall TFormS::RecieveData(WORD *Len, BYTE* Buff)
{
  DWORD NRead;
  bool result = true;
  BYTE Rcv_Byte;
        WORD crc_16 = 0x0000, Length, ind, CRC_Rcv;
        //-- Recieve Marker--
        FT_W32_ReadFile(USB_Device_HANDLE, &Rcv_Byte, 1,&NRead, NULL);
        if (!NRead) {
                result = false;
                return(result);
        }
        //-- Recieve Length--
        Length = 0;
        for (WORD ind = 0; ind < con_UA_LEN_Length; ind++) {
                FT_W32_ReadFile(USB_Device_HANDLE, &Rcv_Byte, 1,&NRead, NULL);
                if (NRead) {
                        Rcv_Byte &= mask_UA_DATA;
                        Length |= (Rcv_Byte << (7*ind));
                } else {
                        result = false;
                        return(result);
                }
        }
        *Len =  Length;
        //-- Recieve Data--
        for (WORD ind = 0; ind < Length; ind++) {
                FT_W32_ReadFile(USB_Device_HANDLE, &Rcv_Byte, 1,&NRead, NULL);
                if (NRead) {
                        Rcv_Byte &= mask_UA_DATA;
                        *(Buff+ind) = Rcv_Byte;
                        crc_16 = update_crc_16(crc_16, Rcv_Byte);
                } else {
                        result = false;
                        return(result);
                }
        }
            //-- Recieve CRC--
        CRC_Rcv = 0;
        for (WORD ind = 0; ind < con_UA_CRC_Length; ind++) {
                FT_W32_ReadFile(USB_Device_HANDLE, &Rcv_Byte, 1,&NRead, NULL);
                if (NRead) {
                        Rcv_Byte &= mask_UA_DATA;
                        CRC_Rcv |= (Rcv_Byte << (7*ind));
                } else {
                        result = false;
                        return(result);
                }
        }
        if ((CRC_Rcv ^ crc_16)) result = true;
        return(result);
}
//------ ---------------------------------------------------------------------
void __fastcall TFormS::ComboBoxInChange(TObject *Sender)
{
        if((USB_Device_HANDLE == NULL)||(USB_Device_HANDLE == INVALID_HANDLE_VALUE))
                Application->MessageBox("Error.\nUSB not open.","",MB_ICONWARNING);
        else
        BufComand[0] = 0x05;
        BufComand[1] = StrToInt(ComboBoxIn->Text);
        TransimittData((BYTE)0x03,(WORD)2,BufComand);
}
//-----------------------------------------------------------------------------
void __fastcall TFormS::CheckBox1Click(TObject *Sender)
{
        if((USB_Device_HANDLE == NULL)||(USB_Device_HANDLE == INVALID_HANDLE_VALUE))
                Application->MessageBox("Error.\nUSB not open.","",MB_ICONWARNING);
        else {
                BufComand[0] = 1;
                BufComand[1] = 0; // Off
                if(CheckBox1->Checked == true) BufComand[1] = 1;// On
                TransimittData((BYTE)0x03,(WORD)2,BufComand);
                SeriesOsc->Clear();
        }
}
//---------------------------------------------------------------------------
void __fastcall TFormS::Button1Click(TObject *Sender)
{
        WORD Len, LenX, ValY, ind;
        short int ValZ, ValX;
        int  ValZmkm, ValXmkm;
        if((USB_Device_HANDLE == NULL)||(USB_Device_HANDLE == INVALID_HANDLE_VALUE))
           return;
        TransimittData(0x05, 0, NULL);
        if(RecieveData(&Len, &UA_Buffer_Data[0])) {
                LenX = (UA_Buffer_Data[1] | (UA_Buffer_Data[2] << 7));
                N_Pixels = LenX;
                for (ind  = 0; ind < 2*LenX; ind++) {
                        ValY = (UA_Buffer_Data[2*ind+3] | (UA_Buffer_Data[2*ind+4] << 7));
                        Result_Data[ind] = ValY;
                }
                SeriesOsc->Clear();
                for (WORD j = 0; j < N_Pixels; j++) {
                        ValZ = Result_Data[2*j];
                        ValX = Result_Data[2*j+1];
                        if (ValZ & 0x2000) ValZ |= 0xC000;
                        if (ValX & 0x2000) ValX |= 0xC000;
                        if ((ValX != (short)con_NoData) && (ValZ != (short)con_NoData)) {
                                ValZmkm = con_Diap_Z*ValZ/con_Prived;
                                ValXmkm = con_Diap_X*ValX/con_Prived;
                                SeriesOsc->AddXY(ValXmkm, ValZmkm, IntToStr(ValXmkm), clRed);
                        }
                }
          }
}
//---------------------------------------------------------------------------
