//---------------------------------------------------------------------------

#ifndef ScenerEMainH
#define ScenerEMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Chart.hpp>
#include <ExtCtrls.hpp>
#include <Series.hpp>
#include <TeEngine.hpp>
#include <TeeProcs.hpp>

//---------------------------------------------------------------------------
//--USB---
FT_HANDLE   USB_Device_HANDLE;
FT_STATUS   USB_Device_Status;
FTTIMEOUTS  USB_Device_cto;
FTDCB       USB_Device_dcb;
DWORD USB_Device_BaudRate;// = 115200;


#define con_UA_LEN_Length	0x02
#define con_UA_CRC_Length	0x03

#define mask_UA_MARKER		0x80
#define mask_UA_Direction	0x40
#define mask_UA_ForAll		0x20
#define mask_UA_Addr		0x7F
#define mask_UA_DATA		0x7F
#define mask_UA_WORD		0x3FFF

//---------------------------------------------------------------------------
#define con_Pixels              640
#define con_Lines               512
#define con_PosZero             220
#define con_dPosZero            10
//---------------------------------------------------------------------------
#define con_Diap_X              30000
#define con_Diap_Z              75000
#define con_Diap_ZB             3000
#define con_Prived              4096
#define con_NoData              0xF000
#define con_X_Delta             3000
#define con_Z_Delta             150
#define con_MotMkm              95000
#define con_MotDelta            con_Z_Delta
#define con_MotSteps            (con_MotMkm/con_MotDelta)
#define con_LinePxl             440

WORD Result_Data[2*con_LinePxl];
BYTE UA_Buffer_Data[20000];
WORD N_Pixels;
BYTE BufComand[5];

class TFormS : public TForm
{
__published:	// IDE-managed Components
        TGroupBox *GroupBox2;
        TCheckBox *CheckBox1;
        TComboBox *ComboBoxIn;
        TStaticText *StaticText4;
        TPanel *Panel1;
        TChart *ChartOscilloscope;
        TPointSeries *SeriesOsc;
        TPointSeries *Series1;
        TButton *Button1;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall CheckBox1Click(TObject *Sender);
        void __fastcall ComboBoxInChange(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TFormS(TComponent* Owner);
        bool __fastcall CreateUSBPort();
        void __fastcall CloseUSBPort();
        void __fastcall TransimittData(BYTE Cm, WORD Len, BYTE* Buff);
        bool __fastcall RecieveData(WORD *Len, BYTE* Buff);
};
//---------------------------------------------------------------------------
extern PACKAGE TFormS *FormS;
//---------------------------------------------------------------------------
#endif
